> ## Documentation Index
> Fetch the complete documentation index at: https://docs.retab.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Delete Block

> Delete a block from a workflow.

This also deletes any edges connected to this block.

Delete a block from a workflow's draft. Every edge connected to the block (incoming or outgoing) is deleted with it — you don't need to clean those up first.

If the block is a container (`while_loop`, `for_each`), its child blocks become orphaned (their `parent_id` is reset to `null`) but are otherwise preserved.

<RequestExample>
  ```python Python theme={null}
  from retab import Retab

  client = Retab()

  client.workflows.blocks.delete(
      "extract-1",
  )
  ```

  ```typescript TypeScript theme={null}
  import { Retab } from "@retab/node";

  const client = new Retab({ apiKey: process.env.RETAB_API_KEY });

  await client.workflows.blocks.delete("extract-1");
  ```

  ```go Go theme={null}
  package main

  import (
  	"context"
  	"log"

  	retab "github.com/retab-dev/retab/clients/go"
  )

  func ptr[T any](v T) *T { return &v }

  func main() {
  	ctx := context.Background()

  	client, err := retab.NewClient("")
  	if err != nil {
  		log.Fatal(err)
  	}

  	if err := client.Workflows.Blocks.Delete(ctx, "extract-1", nil); err != nil {
  		log.Fatal(err)
  	}
  }
  ```

  ```ruby Ruby theme={null}
  require 'retab'

  client = Retab::Client.new(api_key: ENV['RETAB_API_KEY'])

  client.workflows.blocks.delete(block_id: 'extract-1')
  ```

  ```rust Rust theme={null}
  use retab::resources::workflow_blocks::DeleteParams;
  use retab::Retab;

  #[tokio::main]
  async fn main() -> Result<(), Box<dyn std::error::Error>> {
      let client = Retab::new(std::env::var("RETAB_API_KEY")?);

      client
          .workflows().blocks()
          .delete("extract-1", DeleteParams::default())
          .await?;
      Ok(())
  }
  ```

  ```php PHP theme={null}
  <?php
  require 'vendor/autoload.php';

  use Retab\Client;

  $client = new Client(apiKey: getenv('RETAB_API_KEY'));

  $client->workflows()->blocks()->delete(
      blockId: 'blk_extract_1',
  );
  echo "Deleted\n";
  ```

  ```csharp C# theme={null}
  using Retab;
  using RetabClient = Retab.Retab;

  var apiKey = Environment.GetEnvironmentVariable("RETAB_API_KEY")!;
  var client = new RetabClient(apiKey);

  await client.Workflows.Blocks.DeleteAsync("blk_extract_1", new WorkflowBlocksDeleteOptions());
  Console.WriteLine("Deleted");
  ```

  ```java Java theme={null}
  import com.retab.RetabClient;

  public final class Example {
    public static void main(String[] args) throws Exception {
      RetabClient client = new RetabClient(System.getenv("RETAB_API_KEY"));

      var result = client.workflows().blocks().delete("block_abc123", "wf_abc123");
      System.out.println(result);
    }
  }
  ```

  ```curl cURL theme={null}
  curl -X 'DELETE' \
    'https://api.retab.com/v1/workflows/blocks/extract-1' \
    -H 'Authorization: Bearer <your-api-key>'
  ```
</RequestExample>

<ResponseExample>
  ```text 204 theme={null}
  (empty body)
  ```

  ```json 404 theme={null}
  {
    "detail": "Block not found"
  }
  ```
</ResponseExample>


## OpenAPI

````yaml DELETE /v1/workflows/blocks/{block_id}
openapi: 3.1.0
info:
  title: FastAPI
  version: 0.1.0
servers:
  - url: https://api.retab.com
security: []
paths:
  /v1/workflows/blocks/{block_id}:
    delete:
      tags:
        - Workflows
        - Workflow Blocks
      summary: Delete Block
      description: |-
        Delete a block from a workflow.

        This also deletes any edges connected to this block.
      operationId: delete_block
      parameters:
        - in: path
          name: block_id
          required: true
          schema:
            type: string
            title: Block Id
        - in: query
          name: workflow_id
          schema:
            anyOf:
              - type: string
              - type: 'null'
            description: >-
              Disambiguates a block id that is shared by more than one workflow.
              Required only when the block id is not unique within your
              organization.
            title: Workflow Id
          required: false
          description: >-
            Disambiguates a block id that is shared by more than one workflow.
            Required only when the block id is not unique within your
            organization.
      responses:
        '204':
          description: Successful Response
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
      security:
        - HTTPBearer: []
components:
  schemas:
    HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/ValidationError'
          type: array
          title: Detail
          default: []
      type: object
      title: HTTPValidationError
    ValidationError:
      properties:
        loc:
          items:
            anyOf:
              - type: string
              - type: integer
          type: array
          title: Location
        msg:
          type: string
          title: Message
        type:
          type: string
          title: Error Type
        input:
          title: Input
          default: null
        ctx:
          type: object
          title: Context
          default: {}
      type: object
      required:
        - loc
        - msg
        - type
      title: ValidationError
  securitySchemes:
    HTTPBearer:
      type: http
      scheme: bearer

````